﻿var GanttMenu = function () {
    GanttMenu.superclass.constructor.call(this);

}
mini.extend(GanttMenu, mini.Menu, {
    _create: function () {
        GanttMenu.superclass._create.call(this);
	  
        var menuItems = [
            { type: "menuitem", iconCls: "icon-goto", text: mini.Gantt.Goto_Text, name: "goto" },
            '-',
            { type: "menuitem", iconCls: "icon-upgrade", text: mini.Gantt.UpGrade_Text, name: "upgrade" },
            { type: "menuitem", iconCls: "icon-downgrade", text: mini.Gantt.DownGrade_Text, name: "downgrade" },
            '-',
            { type: "menuitem", iconCls: "icon-add", text: mini.Gantt.Add_Text, name: "add" },
            { type: "menuitem", iconCls: "icon-edit", text: mini.Gantt.Add_After, name: "addafter" },
            { type: "menuitem", iconCls: "icon-remove", text: mini.Gantt.Remove_Text, name: "remove" },
            '-',
            { type: "menuitem", iconCls: "icon-zoomin", text: mini.Gantt.Set_Milestone, name: "milestone" }
            //{ type: "menuitem", iconCls: "icon-zoomout", text: mini.Gantt.ZoomOut_Text, name: "zoomout" }
        ];
        this.setItems(menuItems);

        this.goto = mini.getbyName("goto", this);
        this.milestone = mini.getbyName("milestone", this);
        //this.zoomOut = mini.getbyName("zoomout", this);

        this.upgrade = mini.getbyName("upgrade", this);
        this.downgrade = mini.getbyName("downgrade", this);
        this.add = mini.getbyName("add", this);
        this.addAfter = mini.getbyName("addafter", this);
        this.remove = mini.getbyName("remove", this);

        this.goto.on("click", this.__OnGoto, this);
        this.milestone.on("click", this.__SetMilestone, this);
        //this.zoomOut.on("click", this.__OnZoomOut, this);
        this.upgrade.on("click", this.__OnUpgrade, this);
        this.downgrade.on("click", this.__OnDowngrade, this);
        this.add.on("click", this.__OnAdd, this);
        this.addAfter.on("click", this.__OnAddAfter, this);
        this.remove.on("click", this.__OnRemove, this);
    },
    __OnGoto: function (e) {
        var gantt = this.owner;
        var task = gantt.getSelected();
        if (task) {
            gantt.scrollIntoView(task);
        }
    },
  //  __OnZoomIn: function (e) {
   //     var gantt = this.owner;
   //     gantt.zoomIn();
  //  },
    __OnZoomOut: function (e) {
        //var gantt = this.owner;
       // gantt.zoomOut();
	           var gantt = this.owner;
        var task = gantt.getSelected();
        if (task) {
            updateTask(task,{MileMilestone:1});
      }
    },
    __OnUpgrade: function (e) {
        var gantt = this.owner;
        var task = gantt.getSelected();
        if (task) {
            gantt.upgradeTask(task);
        }
    },
    __OnDowngrade: function (e) {
        var gantt = this.owner;
        var task = gantt.getSelected();
        if (task) {
            gantt.downgradeTask(task);
        }
    },
    __SetMilestone: function (e) {
        var gantt = this.owner;
        var task = gantt.getSelected();
        if (task) {
            gantt.updateTask(task,{Milestone:1});
      }
    },
    __OnAdd: function (e) {
        var gantt = this.owner;
        var targetTask = gantt.getSelected();
        var task = gantt.newTask();
		task.Name = '<新增任务>';    //初始化任务属性
        //加到选中任务之前        
        gantt.addTask(task, "before", targetTask);

        //加到子任务
        //gantt.addTask(task, "append", targetTask);
    },
    __OnEdit: function (e) {
        var gantt = this.owner;
        var task = gantt.getSelected();
        if (task) {

        }
    },
    __OnRemove: function (e) {
        var gantt = this.owner;
        var task = gantt.getSelected();
        if (task) {
            if (confirm("确定删除任务 \"" + task.Name + "\" ？")) {
                gantt.removeTask(task);
            }
        } else {
            alert("请选择要删除的任务");
        }
    },
	__OnAddAfter: function (e) {
         var gantt = this.owner;
         var targetTask = gantt.getSelected();
         var task = gantt.newTask();
	   task.Name = '<新增任务>';    //初始化任务属性
         //加到选中任务之后        
         gantt.addTask(task, "after", targetTask);

         //加到子任务
         //gantt.addTask(task, "append", targetTask);
    }
});